
var TObject={
	$ClassName: "TObject",
	$Parent: null,
	ClassName: function (s) { return s.$ClassName },
	ClassType: function (s) { return s },
	ClassParent: function (s) { return s.$Parent },
	$Init: function () {},
	Create: function (s) { return s },
	Destroy: function (s) { for (var prop in s) if (s.hasOwnProperty(prop)) delete s.prop },
	Destroy$: function(s) { return s.ClassType.Destroy(s) },
	Free: function (s) { if (s!==null) s.ClassType.Destroy(s) }
};
var Exception={
	$ClassName: "Exception",
	$Parent: TObject,
	$Init: function () { FMessage="" },
	Create: function (s,Msg) { s.FMessage=Msg; return s }
};
function $New(c) { var i={ClassType:c}; c.$Init(i); return i };
function $Extend(base, sub, props) {
	function F() {};
	F.prototype = base.prototype;
	sub.prototype = new F();
	sub.prototype.constructor = sub;
	for (var n in props) {
		if (props.hasOwnProperty(n)) {
			sub.prototype[n]=props[n];
		}
	}
};
function $CheckFunc(i,z) { if (i) return i; throw Exception.Create($New(Exception),"Function pointer is nil"+z); };
function $Check(i,z) { if (i) return i; throw Exception.Create($New(Exception),"Object not instantiated"+z); };
/// TServer = class (TObject)
///  [line: 23, column: 3, file: Main]
var TServer = {
   $ClassName:"TServer",
   $Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
   }
   /// procedure TServer.Run()
   ///  [line: 50, column: 19, file: Main]
   ,Run:function(Self) {
      var http$1 = null;
      http$1 = http();
      http$1.createServer(function (request$1, response) {
         response.setHeader("Access-Control-Allow-Origin","http://10.10.10.10:8090");
         console_().log(["Serving ",$Check(request$1," in  [line: 60, column: 41, file: Main]").url].slice());
         if ($Check(request$1," in  [line: 61, column: 18, file: Main]").url.substr(0,13)=="/Mileage/Read") {
            TServer.FetchData(Self,response);
         } else if ($Check(request$1," in  [line: 62, column: 23, file: Main]").url.substr(0,13)=="/Mileage/Save") {
            TServer.StoreData(Self,request$1,response);
         } else {
            response.end("MileageServer v0.1");
         }
      }).listen(80,"");
      console_().log(["Server running at http://127.0.0.1:80/"].slice());
   }
   /// procedure TServer.Download(response: JServerResponse; fileName: String)
   ///  [line: 37, column: 19, file: Main]
   ,Download:function(Self, response$1, fileName) {
      fs().readFile(fileName,function (err, data) {
         var sdata = "";
         sdata = "";
         if (data) {
            sdata = data.toString("utf8");
         }
         response$1.end(sdata);
      });
   }
   /// procedure TServer.FetchData(response: JServerResponse)
   ///  [line: 32, column: 19, file: Main]
   ,FetchData:function(Self, response$2) {
      TServer.Download(Self,response$2,"Mileage.txt");
   }
   /// procedure TServer.StoreData(request: JServerRequest; response: JServerResponse)
   ///  [line: 71, column: 19, file: Main]
   ,StoreData:function(Self, request$2, response$3) {
      JServerRequest_Helper$ReadAllData(request$2,function (alldata) {
         fs().writeFile("Mileage.txt",alldata,null);
         response$3.end("");
         console_().log(["Saved data: ",alldata].slice());
      });
   }
   ,Destroy:TObject.Destroy
};
/// JError = class (JObject)
///  [line: 10, column: 3, file: NodeJS.Core]
function JError() {
}
$Extend(Object,JError,
   {
   });

/// JDate = class (JObject)
///  [line: 11, column: 3, file: NodeJS.Core]
function JDate() {
}
$Extend(Object,JDate,
   {
   });

function console_() {
   var Result = null;
    Result = console; return Result
};
/// TwriteFile_options_object = class (TObject)
///  [line: 84, column: 3, file: NodeJS.fs]
var TwriteFile_options_object = {
   $ClassName:"TwriteFile_options_object",
   $Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
   }
   ,Destroy:TObject.Destroy
};
/// TwriteFileSync_options_object = class (TObject)
///  [line: 89, column: 3, file: NodeJS.fs]
var TwriteFileSync_options_object = {
   $ClassName:"TwriteFileSync_options_object",
   $Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
   }
   ,Destroy:TObject.Destroy
};
/// Twatch_options_object = class (TObject)
///  [line: 116, column: 3, file: NodeJS.fs]
var Twatch_options_object = {
   $ClassName:"Twatch_options_object",
   $Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
   }
   ,Destroy:TObject.Destroy
};
/// TwatchFile_options_object = class (TObject)
///  [line: 108, column: 3, file: NodeJS.fs]
var TwatchFile_options_object = {
   $ClassName:"TwatchFile_options_object",
   $Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
   }
   ,Destroy:TObject.Destroy
};
/// TwatchFile_listener_object_fs = class (TObject)
///  [line: 112, column: 3, file: NodeJS.fs]
var TwatchFile_listener_object_fs = {
   $ClassName:"TwatchFile_listener_object_fs",
   $Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
   }
   ,Destroy:TObject.Destroy
};
/// TwatchFile_listener_object = class (TObject)
///  [line: 104, column: 3, file: NodeJS.fs]
var TwatchFile_listener_object = {
   $ClassName:"TwatchFile_listener_object",
   $Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
   }
   ,Destroy:TObject.Destroy
};
/// TreadFile_options_object = class (TObject)
///  [line: 76, column: 3, file: NodeJS.fs]
var TreadFile_options_object = {
   $ClassName:"TreadFile_options_object",
   $Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
   }
   ,Destroy:TObject.Destroy
};
/// TreadFileSync_options_object = class (TObject)
///  [line: 80, column: 3, file: NodeJS.fs]
var TreadFileSync_options_object = {
   $ClassName:"TreadFileSync_options_object",
   $Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
   }
   ,Destroy:TObject.Destroy
};
/// TcreateWriteStream_options_object = class (TObject)
///  [line: 126, column: 3, file: NodeJS.fs]
var TcreateWriteStream_options_object = {
   $ClassName:"TcreateWriteStream_options_object",
   $Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
   }
   ,Destroy:TObject.Destroy
};
/// TcreateReadStream_options_object = class (TObject)
///  [line: 119, column: 3, file: NodeJS.fs]
var TcreateReadStream_options_object = {
   $ClassName:"TcreateReadStream_options_object",
   $Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
   }
   ,Destroy:TObject.Destroy
};
/// TappendFile_options_object = class (TObject)
///  [line: 94, column: 3, file: NodeJS.fs]
var TappendFile_options_object = {
   $ClassName:"TappendFile_options_object",
   $Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
   }
   ,Destroy:TObject.Destroy
};
/// TappendFileSync_options_object = class (TObject)
///  [line: 99, column: 3, file: NodeJS.fs]
var TappendFileSync_options_object = {
   $ClassName:"TappendFileSync_options_object",
   $Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
   }
   ,Destroy:TObject.Destroy
};
function fs() {
   return require("fs");
};
/// TReadableStream_pipe_options_object_stream = class (TObject)
///  [line: 35, column: 3, file: NodeJS.stream]
var TReadableStream_pipe_options_object_stream = {
   $ClassName:"TReadableStream_pipe_options_object_stream",
   $Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
   }
   ,Destroy:TObject.Destroy
};
/// TNodeEventEmitter_listeners_result_object = class (TObject)
///  [line: 25, column: 3, file: NodeJS.events]
var TNodeEventEmitter_listeners_result_object = {
   $ClassName:"TNodeEventEmitter_listeners_result_object",
   $Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
   }
   ,Destroy:TObject.Destroy
};
function http() {
   return require("http");
};
/// TNodeSocket_address_result_object = class (TObject)
///  [line: 43, column: 3, file: NodeJS.net]
var TNodeSocket_address_result_object = {
   $ClassName:"TNodeSocket_address_result_object",
   $Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
   }
   ,Destroy:TObject.Destroy
};
/// procedure JServerRequest_Helper.ReadAllData(Self: JServerRequest; aCallback: procedure (aData: Variant))
///  [line: 15, column: 33, file: NodeJS.http.helpers]
function JServerRequest_Helper$ReadAllData(Self$1, aCallback) {
   var alldata$1 = "";
   Self$1.on("data",function (chunk) {
      alldata$1+=""+chunk;
   });
   Self$1.on("end",function (dummy) {
      $CheckFunc(aCallback," in  [line: 29, column: 16, file: NodeJS.http.helpers]")(alldata$1);
   });
}
var Server = null;
var $Application = function() {
   Server = TObject.Create($New(TServer));
   TServer.Run(Server);
}
$Application();

